/**
 *  OpenKM, Open Document Management System (http://www.openkm.com)
 *  Copyright (c) 2006-2014  Paco Avila & Josep Llort
 *
 *  No bytes were intentionally harmed during the development of this application.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package com.openkm.extension.frontend.client.widget.customer.sample;

import java.util.ArrayList;
import java.util.List;

import com.google.gwt.user.client.ui.Widget;
import com.openkm.frontend.client.extension.event.HasLanguageEvent.LanguageEventConstant;
import com.openkm.frontend.client.extension.event.handler.LanguageHandlerExtension;

/**
 * sample
 * 
 * @author jllort
 *
 */
public class sample implements LanguageHandlerExtension {
	public static final int TAB_DOCUMENT 	= 0;
	public static final int TAB_FOLDER 		= 1;
	public static final int TAB_MAIL		= 2;
	
	private static final String UUID = "c7f86df0-007b-11e1-be50-0800200c9a66";
	private int selectedPanel = TAB_FOLDER;  // By default the folder tab is selected at starting 
	private static sample singleton;
	private ExtendedSecurityTabDocument extendedSecurityTabDocument;
	//private ExtendedSecurityTabFolder extendedSecurityTabFolder;
	//private ExtendedSecurityTabMail extendedSecurityTabMail;
	public Status status;
	
	/**
	 * sample
	 */
	public sample(List<String> uuidList) {
		singleton = this;
		if (isRegistered(uuidList)) {
			extendedSecurityTabDocument = new ExtendedSecurityTabDocument();
			//extendedSecurityTabFolder = new ExtendedSecurityTabFolder();
			//extendedSecurityTabMail = new ExtendedSecurityTabMail();
			status = new Status();
			status.setStyleName("okm-StatusPopup");
		}
	}
	
	/**
	 * getExtensions
	 * 
	 * @return
	 */
	public List<Object> getExtensions() {
		List<Object> extensions = new ArrayList<Object>();
		extensions.add(extendedSecurityTabDocument);
		//extensions.add(extendedSecurityTabFolder);
		//extensions.add(extendedSecurityTabMail);
		extensions.add(singleton);
		return extensions;
	}
	
	/**
	 * get
	 * 
	 * @return
	 */
	public static sample get() {
		return singleton;
	}
	
	@Override
	public void onChange(LanguageEventConstant event) {
		extendedSecurityTabDocument.langRefresh();
		//extendedSecurityTabFolder.langRefresh();
		//extendedSecurityTabMail.langRefresh();
	}
	
	/**
	 * getWidgetTab
	 * 
	 * @return
	 */
	public Widget getWidgetTab() {
		Widget widget = null;
		
		if (selectedPanel == TAB_DOCUMENT) {
			widget = extendedSecurityTabDocument;
		} else if (selectedPanel == TAB_FOLDER) {
			widget = extendedSecurityTabFolder;
		} else if (selectedPanel == TAB_MAIL) {
			widget =  extendedSecurityTabMail;
		} else if (selectedPanel == TAB_RECORD) {
			widget =  extendedSecurityTabRecord;
		}
		
		return widget;
	}
	
	/**
	 * setTabDocumentSelected
	 */
	public void setTabDocumentSelected() {
		selectedPanel = TAB_DOCUMENT;
	}
	
	/**
	 * setTabFolderSelected
	 */
	public void setTabFolderSelected() {
		selectedPanel = TAB_FOLDER;
	}
	
	/**
	 * setTabMailSelected
	 */
	public void setTabMailSelected() {
		selectedPanel = TAB_MAIL;
	}
	
	/**
	 * isRegistered
	 * 
	 * @param uuidList
	 * @return
	 */
	public static boolean isRegistered(List<String> uuidList) {
		return uuidList.contains(UUID);
	}
}
